searchNodes=[{"doc":"Utilities to create the queues, topics, and subscriptions required to support the ingest pipeline.","ref":"Sequins.html","title":"Sequins","type":"module"},{"doc":"","ref":"Sequins.html#inflect/1","title":"Sequins.inflect/1","type":"function"},{"doc":"","ref":"Sequins.html#parse_filters/1","title":"Sequins.parse_filters/1","type":"function"},{"doc":"","ref":"Sequins.html#parse_queues/1","title":"Sequins.parse_queues/1","type":"function"},{"doc":"","ref":"Sequins.html#parse_subscriptions/1","title":"Sequins.parse_subscriptions/1","type":"function"},{"doc":"","ref":"Sequins.html#parse_topics/1","title":"Sequins.parse_topics/1","type":"function"},{"doc":"","ref":"Sequins.html#prefix/0","title":"Sequins.prefix/0","type":"function"},{"doc":"Set up pipeline infrastructure based on a list of queue/topic/subscription specs. A spec looks like this:{Action, [{OtherAction, [filters]}, ...]}An action with no subscriptions can simply be specified asActionFor example, let's say you have 4 actions – A (do some things), B &amp; C (do some things; depend on A's success), and D (handles all errors). The spec for this would be:[ :A, B: [A: [status: :ok]], C: [A: [status: :ok]], D: [A: [status: :error], B: [status: :error], C: [status: :error]] ]The above spec will create:4 SQS queues (sequins-a, sequins-c, sequins-c, sequins-d)4 SNS topics (sequins-a, sequins-c, sequins-c, sequins-d)5 SNS subscriptionssequins-a -&gt; sequins-b ({&quot;status&quot;: &quot;ok&quot;})sequins-a -&gt; sequins-c ({&quot;status&quot;: &quot;ok&quot;})sequins-a -&gt; sequins-d ({&quot;status&quot;: &quot;error&quot;})sequins-b -&gt; sequins-d ({&quot;status&quot;: &quot;error&quot;})sequins-c -&gt; sequins-d ({&quot;status&quot;: &quot;error&quot;})The default prefix for created resources is sequins, but can be changed by configuring the :sequins application's :prefix attribute. The options passed to the supervisor on startup can be specified by setting the :supervisor_opts attribute to a keyword list of valid Supervisor options.In addition to :status, subscriptions can filter on any attribute added to the attrs hash by the Sequins.Pipeline.Action.process/2 callback.","ref":"Sequins.html#setup/1","title":"Sequins.setup/1","type":"function"},{"doc":"","ref":"Sequins.html#start_children/1","title":"Sequins.start_children/1","type":"function"},{"doc":"","ref":"Sequins.html#t:filter/0","title":"Sequins.filter/0","type":"type"},{"doc":"","ref":"Sequins.html#t:spec/0","title":"Sequins.spec/0","type":"type"},{"doc":"","ref":"Sequins.html#t:specs/0","title":"Sequins.specs/0","type":"type"},{"doc":"","ref":"Sequins.html#t:stringish/0","title":"Sequins.stringish/0","type":"type"},{"doc":"","ref":"Sequins.html#t:subscription/0","title":"Sequins.subscription/0","type":"type"},{"doc":"","ref":"Sequins.html#t:subscriptions/0","title":"Sequins.subscriptions/0","type":"type"},{"doc":"Sequins.Pipeline provides a wrapper to group actions into processing pipelines.# my_pipeline.ex defmodule MyPipeline do use Sequins.Pipeline end # config.exs config :sequins, supervisor_opts: [ max_restarts: 100, strategy: :one_for_all ] config :sequins, MyPipeline, actions: [ActionOne, ActionTwo, ActionThree] config :sequins, ActionTwo, queue_config: [max_number_of_messages: 3, visibility_timeout: 180], notify_on: [ActionOne: [status: :ok]] # application.ex def start(_type, _args) do # Start other processes here MyPipeline.start() end","ref":"Sequins.Pipeline.html","title":"Sequins.Pipeline","type":"module"},{"doc":"","ref":"Sequins.Pipeline.html#actions/1","title":"Sequins.Pipeline.actions/1","type":"function"},{"doc":"","ref":"Sequins.Pipeline.html#children/1","title":"Sequins.Pipeline.children/1","type":"function"},{"doc":"","ref":"Sequins.Pipeline.html#queue_config/1","title":"Sequins.Pipeline.queue_config/1","type":"function"},{"doc":"Sequins.Pipeline.Action wraps a Broadway SQS processing pipeline to allow for the simple creation of multi-stage SQS -&gt; Broadway -&gt; SNS pipelines.Getting StartedFirst, follow the Create a SQS queue and Configure the project sections of the Broadway Amazon SQS guide.Also make sure config.exs contains a valid ExAws configuration.Implement the processing callbackThis is where we depart from Broadway's default implementation. Pipeline.Action makes several opinionated assumptions about the AWS environment as well as the shape of the incoming message data.ProcessorSequins.Pipeline.Action does some pre- and post-processing of the Broadway.Message struct. Instead of implementing handle_message/3, we're just going to implement our own process/2, which recieves two parameters:data: The Message field of the incoming SQS messageattrs: The MessageAttributes field of the incoming SQS messageattrs (and data, if it's a map) is converted from &quot;CamelCaseStringKeys&quot; to :underscore_atom_keys before being passed to process/2.process/2's return value should be one of the following:{status, data, attrs} (if both data and attrs have been updated){status, data} (if data has been updated){status} or status (if no data/attribute updates are needed)The status will be added to the attrs of the next message in the pipeline.Example:defmodule MyApplication.MyPipeline do use Pipeline.Action def process(data, attrs) do {:ok, data |&gt; Map.get_and_update!(:value, fn n -&gt; n * n end)} end endBy default, the queue and topic names are imputed based on the last segment of the using module name (e.g., sequins-my-pipeline for a module ending in MyPipeline). This can be overridden by passing a :queue_name option to use:defmodule MyApplication.MyPipeline do use Pipeline.Action, queue_name: &quot;my_pipeline&quot; ... endThe default resource prefix is sequins, but can be changed by configuring the :sequins application's :prefix attribute.BatcherSequins.Pipeline.Action sends processed data to an AWS Simple Notification Service topic, allowing it to be dispatched to another queue (and into another Sequins.Pipeline.Action), an AWS Lambda, an arbitrary webhook, or even an email or SMS message.Configuration OptionsSequins.Pipeline.Action attempts to use sane defaults, inheriting most of them from Broadway itself. However, several can be overriden in the application configuration.OptionsSequins.Pipeline.Action is configured by passing options to start_link. Valid options are::receive_interval - Optional. The frequency with which the produer polls SQS for new messages. Default value is 5000.:producer_stages - Optional. The number of producer stages to be created by Broadway. Analogous to Broadway's producer :stages option. Default value is 1.:processor_stages - Optional. The number of processor stages to be created by Broadway. Analogous to Broadway's producer :stages option. Default value is 1.:max_demand - Optional. Set the maximum demand of all processors stages. Analogous to Broadway's processor :max_demand option. Default value is 10.:min_demand - Optional. Set the minimum demand of all processors stages. Analogous to Broadway's processor :min_demand option. Default value is 5.:batcher_stages - Optional. The number of batcher stages to be created by Broadway. Analogous to Broadway's batcher :stages option. Default value is 1.:batch_size - Optional. The size of generated batches. Analogous to Broadway's batcher :batch_size option. Default value is 100.:batch_timeout - Optional. The time, in milliseconds, that the batcher waits before flushing the list of messages. Analogous to Broadway's batcher :batch_timeout option. Default value is 1000.","ref":"Sequins.Pipeline.Action.html","title":"Sequins.Pipeline.Action","type":"behaviour"},{"doc":"","ref":"Sequins.Pipeline.Action.html#c:process/2","title":"Sequins.Pipeline.Action.process/2","type":"callback"},{"doc":"","ref":"Sequins.Pipeline.Action.html#start_link/2","title":"Sequins.Pipeline.Action.start_link/2","type":"function"},{"doc":"","ref":"Sequins.Pipeline.Action.html#t:action_option/0","title":"Sequins.Pipeline.Action.action_option/0","type":"type"},{"doc":"","ref":"Sequins.Pipeline.Action.html#t:action_options/0","title":"Sequins.Pipeline.Action.action_options/0","type":"type"},{"doc":"Functions for converting Broadway SQS messages into Sequins messages and preparing the results for SNS","ref":"Sequins.Pipeline.Data.html","title":"Sequins.Pipeline.Data","type":"module"},{"doc":"Convert SQS message attributes to a map","ref":"Sequins.Pipeline.Data.html#attrs_to_map/1","title":"Sequins.Pipeline.Data.attrs_to_map/1","type":"function"},{"doc":"Extract processable data and attributes from an SQS Broadway.Message","ref":"Sequins.Pipeline.Data.html#extract/1","title":"Sequins.Pipeline.Data.extract/1","type":"function"},{"doc":"Convert a map to SQS message attributes","ref":"Sequins.Pipeline.Data.html#map_to_attrs/1","title":"Sequins.Pipeline.Data.map_to_attrs/1","type":"function"},{"doc":"Assemble the return value to hand off to the SNS batcher","ref":"Sequins.Pipeline.Data.html#update/2","title":"Sequins.Pipeline.Data.update/2","type":"function"},{"doc":"","ref":"Sequins.Pipeline.Data.html#t:t/0","title":"Sequins.Pipeline.Data.t/0","type":"type"},{"doc":"Utilities for parsing and manipulating AWS ARNs","ref":"Sequins.Utils.Arn.html","title":"Sequins.Utils.Arn","type":"module"},{"doc":"Parse an ARN into a struct","ref":"Sequins.Utils.Arn.html#parse/1","title":"Sequins.Utils.Arn.parse/1","type":"function"},{"doc":"Convert an ARN struct to a string","ref":"Sequins.Utils.Arn.html#to_string/1","title":"Sequins.Utils.Arn.to_string/1","type":"function"},{"doc":"Update the ARN account","ref":"Sequins.Utils.Arn.html#update_account/2","title":"Sequins.Utils.Arn.update_account/2","type":"function"},{"doc":"Update the ARN partition","ref":"Sequins.Utils.Arn.html#update_partition/2","title":"Sequins.Utils.Arn.update_partition/2","type":"function"},{"doc":"Update the ARN region","ref":"Sequins.Utils.Arn.html#update_region/2","title":"Sequins.Utils.Arn.update_region/2","type":"function"},{"doc":"Update the ARN resource","ref":"Sequins.Utils.Arn.html#update_resource/2","title":"Sequins.Utils.Arn.update_resource/2","type":"function"},{"doc":"Update the ARN scheme","ref":"Sequins.Utils.Arn.html#update_scheme/2","title":"Sequins.Utils.Arn.update_scheme/2","type":"function"},{"doc":"Update the ARN service","ref":"Sequins.Utils.Arn.html#update_service/2","title":"Sequins.Utils.Arn.update_service/2","type":"function"},{"doc":"","ref":"Sequins.Utils.Arn.html#t:new_value/0","title":"Sequins.Utils.Arn.new_value/0","type":"type"},{"doc":"","ref":"Sequins.Utils.Arn.html#t:t/0","title":"Sequins.Utils.Arn.t/0","type":"type"},{"doc":"","ref":"Sequins.Utils.Arn.html#t:update_function/0","title":"Sequins.Utils.Arn.update_function/0","type":"type"}]